--------------------------------------------------------------------------------
-- Company: UNIVERSITY OF CONNECTICUT
-- Engineer: Farrukh Hijaz
--
-- Create Date:    09/30/2015
-- Design Name:    
-- Module Name:    sram16ctl - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity sram16ctl is

	Port ( clk_i : in std_logic;
          rst_i : in std_logic;
          adr_i : in std_logic_vector(31 downto 0);
          dat_i : in std_logic_vector(31 downto 0);
          dat_o : out std_logic_vector(31 downto 0);
          ack_o : out std_logic;
          stb_i : in std_logic;
          we_i  : in std_logic;
          MemAdr : out std_logic_vector(23 downto 1);
          MemOE : out std_logic;
          MemWR : out std_logic;
          MemDB : inout std_logic_vector(15 downto 0);
          RamCS : out std_logic;
          RamUB : out std_logic;
          RamLB : out std_logic;
          RamAdv : out std_logic;
          RamClk : out std_logic;
          RamCRE : out std_logic
		);
end sram16ctl;

architecture Behavioral of sram16ctl is
	signal we : std_logic;
begin
-- Design a state machine that reads or writes, based on we_i, to the SRAM.
-- The state machine will apply the signals and then wait for 4 cycles for the SRAM timing to be met.
-- Then change the address/data appropriately and wait for another 4 cycles.
-- MemAdr(23 downto 2) should be assigned adr_i(23 downto 2), while you will have to assert MemAdr(1) for the first 16-bits 
-- access (for the first set of 4 wait cycles) and de-assert it for the 2nd 16-bits access (for the second set of 4 wait cycles).
-- While writing to SRAM, assign lower 16-bits of data to MemDB for the first access and higher 16-bits for the 2nd access, 'Z' otherwise.




	MemAdr(23 downto 2) <= adr_i(23 downto 2);
	-- Assert MemAdr(1) during the wait cycles for first access and de-assert it during the wait cycles for 2nd access.
	

	
	we <= '0' when we_i='1' and stb_i='1' else '1';
	MemWR <= we;
	

	RamCS <= not stb_i;
	MemOE <= '0';
	RamUB <= 0;
	RamLB <= 0;

	
	-- Pseudo-SRAM is operated in asynchronous mode
	RamAdv <= '0';
	RamClk <= '0';
	RamCRE <= '0';

end Behavioral;
